package italo.comecome;

import java.util.Collection;

import italo.comecome.gui.evento.EntradaJanela;
import italo.comecome.logica.Jogo;
import italo.comecome.truque.Truque;

public class HandlerEntradaJanela extends EntradaJanela {

	private Jogo jogo;
	private JogoFrame jogoFrame;
	private boolean undecorated;
	
	public HandlerEntradaJanela(JogoFrame jogoFrame, Jogo jogo) {
		this.jogoFrame = jogoFrame;
		this.jogo = jogo;		
		this.undecorated = jogoFrame.isUndecorated();
	}

	public void escPressionado() {
		jogo.sair();
	}
	
	public void altEnterPressionado() {
		undecorated = !undecorated;
		jogoFrame.dispose();
		jogoFrame.setUndecorated(undecorated);
		jogoFrame.setVisible(true);
	}
	
	public void teclaPressionada(char tecla) {
		Collection<Truque> truques = jogo.getTruquesJanela().values(); 
		for(Truque t:truques)
			t.teclaPressionada(tecla);		
	}
	
}
