package italo.comecome;

import java.util.Collection;

import italo.comecome.entrada.Entrada;
import italo.comecome.gui.desenho.DesenhoMenu;
import italo.comecome.gui.evento.EntradaMenu;
import italo.comecome.gui.figura.Figura;
import italo.comecome.logica.Jogo;
import italo.comecome.truque.Truque;

public class HandlerEntradaMenuOpcoes extends EntradaMenu {
	
	private final static String CAMINHO_MENU_OPCOES = Figura.CAMINHO_MENU+"2/";
	private final static String CAMINHO_MENU_OPCAO = Figura.CAMINHO_MENU+2+Figura.EXT;
		
	private HandlerEntradaMenuJogo handlerMJ;
	private Entrada entrada;
	private DesenhoMenu menu;
	private Jogo jogo;		
	
	private int opcao = 1;
	
	public HandlerEntradaMenuOpcoes(HandlerEntradaMenuJogo handlerMJ, Entrada entrada, DesenhoMenu menu, Jogo jogo) {
		this.handlerMJ = handlerMJ;
		this.entrada = entrada;
		this.menu = menu;
		this.jogo = jogo;
	}
	
	public void prabaixoPressionado() {		
		opcao = (opcao < 2 ? opcao+1: 1);
		menu.desenhar(CAMINHO_MENU_OPCOES+opcao+"/"+jogo.getDificuldade()+Figura.EXT);
	}

	public void pracimaPressionado() {
		opcao = (opcao > 1 ? opcao-1: 2);
		menu.desenhar(CAMINHO_MENU_OPCOES+opcao+"/"+jogo.getDificuldade()+Figura.EXT);
	}

	public void prafrentePressionado() {
		if(opcao == 1) {
			int dificuldade = jogo.getDificuldade();
			jogo.setDificuldade(dificuldade < 4 ? dificuldade+1: 1);
			menu.desenhar(CAMINHO_MENU_OPCOES+opcao+"/"+jogo.getDificuldade()+Figura.EXT);
		}
	}

	public void pratrazPressionado() {
		if(opcao == 1) {
			int dificuldade = jogo.getDificuldade();
			jogo.setDificuldade(dificuldade > 1 ? dificuldade-1: 4);
			menu.desenhar(CAMINHO_MENU_OPCOES+opcao+"/"+jogo.getDificuldade()+Figura.EXT);
		}
	}

	public void startPressionado() {
		if(opcao == 2) {
			entrada.removeTecladoListener(this);	
			entrada.addTecladoListener(handlerMJ);
			menu.desenhar(CAMINHO_MENU_OPCAO);		
		}
	}
	
	public void teclaPressionada(char tecla) {
		Collection<Truque> truques = jogo.getTruquesMenuOpcoes().values(); 
		for(Truque t:truques)
			t.teclaPressionada(tecla);		
	}

}
