package italo.comecome;

import italo.comecome.audio.Audio;
import italo.comecome.gui.ContainerJogo;
import italo.comecome.logica.Jogo;
import italo.comecome.truque.Truque;
import italo.comecome.truque.TruqueListener;

public class HandlerTruqueAtravessarParedes implements TruqueListener {
	
	private Jogo jogo;
	private ContainerJogo container;
	
	public HandlerTruqueAtravessarParedes(Jogo jogo, ContainerJogo container) {
		this.jogo = jogo;
		this.container = container;
	}
	
	public void truqueCompleto(Truque truque) {
		boolean atravessarParedes = (truque.getStatus() == Truque.TRUQUE_ATIVO);
		container.playAudioClip(atravessarParedes ? Audio.ATRAVESSAR_PAREDES : Audio.NAO_ATRAVESSAR_PAREDES);
		jogo.setAtravessarParedes(atravessarParedes);
	}

}
