package italo.comecome;

import italo.comecome.audio.Audio;
import italo.comecome.gui.ContainerJogo;
import italo.comecome.logica.Jogo;
import italo.comecome.truque.Truque;
import italo.comecome.truque.TruqueListener;

public class HandlerTruqueMudarNumeroDeVidas implements TruqueListener {
	
	private Jogo jogo;
	private ContainerJogo container;
	
	public HandlerTruqueMudarNumeroDeVidas(Jogo jogo, ContainerJogo container) {
		this.jogo = jogo;
		this.container = container;
	}
	
	public void truqueCompleto(Truque truque) {
		char[] truqueValor = truque.getTruque();
		char[] truqueDigitadoValor = truque.getTruqueDigitado();
		try {						
			String nVidasStr = "";
			for(int i = truqueValor.length-1; truqueValor[i] == Truque.CORINGA; i--)
				nVidasStr = (truqueDigitadoValor[i]+nVidasStr);  			
			if(nVidasStr.equals("")) {
				container.playAudioClip(Audio.OOPS);
				jogo.setNVidas(Integer.MAX_VALUE);
			} else {
				int nVidas = Integer.parseInt(nVidasStr);
				if(nVidas > 0) {			
					container.playAudioClip(Audio.OOPS);
					jogo.setNVidas(nVidas);
				}
			}		
		} catch (NumberFormatException e) {
			
		}
	}

}
