package italo.comecome.conf;

import italo.comecome.personagem.util.PersonagemUtil;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class ConfUtil {
	
	public static String getConteudoArquivo(String caminho) {
		try {
			InputStream in = new FileInputStream(caminho);
			BufferedReader input = new BufferedReader(new InputStreamReader(in));
			String conteudo = "";
			String linha = input.readLine();
			while(linha != null) {
				conteudo += (linha+"\n");
				linha = input.readLine();
			}
			return conteudo;
		} catch(IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static boolean[][] getVetorBoolean(String dadosStr){
		StringTokenizer tokenizer = new StringTokenizer(dadosStr);
		int iniSubString = 0;
		int fimSubString = dadosStr.indexOf("\n");
		if(fimSubString < 0)
			return null;
		String linha = dadosStr.substring(iniSubString, fimSubString);
		StringTokenizer tokenizerLinha = new StringTokenizer(linha);
		int nTokens = tokenizer.countTokens();
		int nColunas = tokenizerLinha.countTokens();
		int nLinhas = nTokens/nColunas;		
		boolean[][] dados = new boolean[nLinhas][nColunas];
		try{
			int i = 0;
			while(tokenizer.hasMoreTokens()){
				for(int j = 0; j < nColunas; j++)
					dados[i][j] = Boolean.parseBoolean(tokenizer.nextToken());									
				i++;
			}
			if(i != nLinhas)
				return null;			
			return dados;
		}catch(NumberFormatException e){
			e.printStackTrace();	
		}
		return null;
	}
	
	public static int[][] getVetorInteger(String dadosStr){
		StringTokenizer tokenizer = new StringTokenizer(dadosStr);
		int iniSubString = 0;
		int fimSubString = dadosStr.indexOf("\n");
		if(fimSubString < 0)
			return null;		
		String linha = dadosStr.substring(iniSubString, fimSubString);
		StringTokenizer tokenizerLinha = new StringTokenizer(linha);
		int nTokens = tokenizer.countTokens();
		int nColunas = tokenizerLinha.countTokens();
		int nLinhas = nTokens/nColunas;
		int[][] dados = new int[nLinhas][nColunas];
		try{
			int i = 0;
			while(tokenizer.hasMoreTokens()){
				for(int j = 0; j < nColunas; j++)
					dados[i][j] = Integer.parseInt(tokenizer.nextToken());									
				i++;
			}
			if(i != nLinhas) 
				return null;			
			return dados;
		}catch(NumberFormatException e){
			e.printStackTrace();			
		}
		return null;
	}
	
	public static int[][] getVetorDirecoesIniciaisMonstrinhos(String dadosStr, int nMonstrinhos, int fatorMC){
		StringTokenizer tokenizer = new StringTokenizer(dadosStr);		
		int[][] dados = new int[nMonstrinhos][];
		try{
			for(int i = 0; i < dados.length; i++) {
				String linha = tokenizer.nextToken("\n");
				StringTokenizer tokenizerLinha = new StringTokenizer(linha);
				int nTokens = tokenizerLinha.countTokens();
				dados[i] = new int[nTokens*fatorMC];
				int indice = 0;
				for(int j = 0; j < nTokens; j++) {
					int direcao = PersonagemUtil.getDirecao(tokenizerLinha.nextToken());
					for(int k = 0; k < fatorMC; k++) {
						dados[i][indice] = direcao;
						indice++;
					}
				}
			}		
			return dados;
		}catch(NumberFormatException e){
			e.printStackTrace();			
		}
		return null;
	}
	
}
