package italo.comecome.gui.evento;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public abstract class EntradaJogo implements KeyListener {

	public final static int PARAR = 0;
	public final static int CONTINUAR = 1;
	
	private boolean altPressionado = false;	
	private int pararContinuar = CONTINUAR;
	
	public void iniciar() {
		altPressionado = false;
		pararContinuar = CONTINUAR;
	}
	
	public void keyPressed(KeyEvent e){		
		teclaPressionada(e.getKeyChar(), (pararContinuar == PARAR));
		if(e.getKeyCode() == KeyEvent.VK_LEFT) {
			pratrazPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
			prafrentePressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_DOWN) {
			prabaixoPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_UP) {
			pracimaPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			if(!altPressionado) {
				pararContinuar = (pararContinuar == CONTINUAR ? PARAR : CONTINUAR);
				pararcontinuarPressionado(pararContinuar);
			}
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = true;
		}		
	}
	
	public void keyReleased(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = false;
		}
	}

	public void keyTyped(KeyEvent e) {
		
	}

	public abstract void teclaPressionada(char tecla, boolean jogoParado);
	public abstract void prafrentePressionado();
	public abstract void pratrazPressionado();
	public abstract void prabaixoPressionado();
	public abstract void pracimaPressionado();
	public abstract void pararcontinuarPressionado(int pararContinuar);
	
}
