package italo.comecome.gui.evento;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public abstract class EntradaMenu implements KeyListener {

	private boolean altPressionado = false;
			
	public void iniciar() {
		altPressionado = false;
	}
	
	public void keyPressed(KeyEvent e){
		teclaPressionada(e.getKeyChar());
		if(e.getKeyCode() == KeyEvent.VK_LEFT) {
			pratrazPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
			prafrentePressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_DOWN) {
			prabaixoPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_UP) {
			pracimaPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			if(!altPressionado)
				startPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = true;
		}
	}
	
	public void keyReleased(KeyEvent e){
		altPressionado = false;
	}
	
	public void keyTyped(KeyEvent e) {}

	public abstract void teclaPressionada(char tecla);
	public abstract void prafrentePressionado();
	public abstract void pratrazPressionado();
	public abstract void prabaixoPressionado();
	public abstract void pracimaPressionado();
	public abstract void startPressionado();
	
}

