package italo.comecome.gui.figura;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.ImageObserver;

public class Imagem {

	private Image image;	
	private int largura;
	private int altura;
	private int x = 0;
	private int y = 0;
	
	public Imagem(Figura figura, String caminho) {
		this(figura, caminho, 0, 0);
	}
	
	public Imagem(Figura figura, String caminho, int largura, int altura) {
		this.image = figura.getImage(caminho); 
		this.altura = altura;
		this.largura = largura;
	}
		
	public void desenhar(Graphics g, ImageObserver tPanel) {
		Graphics2D g2D = (Graphics2D)g;
		if(largura != 0 && altura != 0) {			
			g2D.drawImage(image, x, y, largura, altura, tPanel);
		} else {
			g2D.drawImage(image, x, y, tPanel);			
		}
	}
	
	public void setDim(int largura, int altura) {
		setLargura(largura);
		setAltura(altura);
	}
	
	public void setPosicao(int x, int y) {
		setX(x);
		setY(y);
	}

	public int getLargura() {
		return largura;
	}

	public void setLargura(int largura) {
		this.largura = largura;
	}

	public int getAltura() {
		return altura;
	}

	public void setAltura(int altura) {
		this.altura = altura;
	}

	public int getX() {
		return x;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getY() {
		return y;
	}

	public void setY(int y) {
		this.y = y;
	}

	public Image getImage() {
		return image;
	}
		
}
