package italo.comecome;

import italo.comecome.gui.evento.EntradaJogo;
import italo.comecome.logica.Fase;
import italo.comecome.logica.Jogo;
import italo.comecome.personagem.Personagem;
import italo.comecome.truque.Truque;

import java.util.Collection;

public class HandlerEntradaJogo extends EntradaJogo {

	private Jogo jogo;
	
	public HandlerEntradaJogo(Jogo jogo) {
		this.jogo = jogo;
	}
	
	public void pararcontinuarPressionado(int pararContinuar) {		
		if(pararContinuar == EntradaJogo.PARAR) {
			jogo.pararExecucao();		
		} else {
			jogo.continuarExecucao();
		}
	}

	public void prabaixoPressionado() {
		Fase fase = jogo.getFaseAtual();
		if(fase != null)
			fase.getComeCome().setNovaDirecao(Personagem.BAIXO);
	}

	public void pracimaPressionado() {
		Fase fase = jogo.getFaseAtual();
		if(fase != null)
			fase.getComeCome().setNovaDirecao(Personagem.CIMA);
	}

	public void prafrentePressionado() {
		Fase fase = jogo.getFaseAtual();
		if(fase != null)
			fase.getComeCome().setNovaDirecao(Personagem.FRENTE);
	}

	public void pratrazPressionado() {
		Fase fase = jogo.getFaseAtual();
		if(fase != null)
			fase.getComeCome().setNovaDirecao(Personagem.TRAZ);
	}
	
	public void teclaPressionada(char tecla, boolean jogoParado) {
		if(jogoParado) {
			Collection<Truque> truques = jogo.getTruquesJogo().values(); 
			for(Truque t:truques)
				t.teclaPressionada(tecla);
		}
	}
	
}
