package italo.comecome;

import italo.comecome.logica.Jogo;
import italo.comecome.truque.Truque;
import italo.comecome.truque.TruqueListener;

public class HandlerTruqueMudarDeFase implements TruqueListener {
	
	private Jogo jogo;
	
	public HandlerTruqueMudarDeFase(Jogo jogo) {
		this.jogo = jogo;
	}
	
	public void truqueCompleto(Truque truque) {						
		try {
			char[] truqueDigitado = truque.getTruqueDigitado();
			int nFase = Integer.parseInt(String.valueOf(truqueDigitado[truqueDigitado.length-1]))-1;
			if(nFase < jogo.getFases().length && nFase != jogo.getIndiceFaseAtual()) {
				jogo.getFaseAtual().getComeCome().setMudarFase(true);		
				jogo.getFaseAtual().finalizar();
				jogo.mudarDeFase(nFase);				
			}
		} catch (NumberFormatException e) {
			
		}		
	}		

}
