package italo.comecome.conf;

import italo.comecome.audio.Audio;
import italo.comecome.gui.figura.Figura;
import italo.comecome.logica.Fase;
import italo.comecome.logica.Jogo;
import italo.comecome.logica.TabuleiroException;
import italo.comecome.truque.Truque;

import javax.swing.JOptionPane;

class Conf2 {
					
	private static Conf2 conf;
	
	public final static int NUMERO_DE_VIDAS = 5;
	public final static int DIFICULDADE = 4;
	public final static char[] TRUQUE_ATRAVESSAR_PAREDES = {'a', 't', 'r', 'a', 'v', 'e', 's', 's', 'a', 'r', ' ', 'p', 'a', 'r', 'e', 'd', 'e', 's'};
	public final static char[] TRUQUE_MUDAR_DE_FASE = {'f', 'a', 's', 'e', '?'};
	public final static char[] TRUQUE_MUDAR_NUMERO_DE_VIDAS = {'v', 'i', 'd', 'a', 's', '?', '?', '?'};
		
	public final static String[] CAMINHOS_IMAGENS = {
				
		// menus
		
		"img/menu/1.gif",
		"img/menu/2.gif",
		"img/menu/3.gif",
		"img/menu/2/1/1.gif",
		"img/menu/2/1/2.gif",
		"img/menu/2/1/3.gif",
		"img/menu/2/1/4.gif",
		"img/menu/2/2/1.gif",
		"img/menu/2/2/2.gif",
		"img/menu/2/2/3.gif",
		"img/menu/2/2/4.gif",
		
		// mensagens 
		
		"img/mensagens/vidas/1.gif",
		"img/mensagens/vidas/2.gif",
		"img/mensagens/vidas/3.gif",
		"img/mensagens/vidas/4.gif",
		"img/mensagens/gameover.gif",
		"img/mensagens/passou.gif",
		"img/mensagens/zerou.gif",
		"img/mensagens/pausa.gif",
		
		// tabuleiros
		
		"img/tabuleiro/1.gif", 
		"img/tabuleiro/2.gif",
		"img/tabuleiro/3.gif", 
		"img/tabuleiro/4.gif", 
		"img/tabuleiro/5.gif", 
		
		// comecome
		
		"img/comecome/frente/1.gif",
		"img/comecome/frente/2.gif",
		"img/comecome/frente/3.gif",
		"img/comecome/baixo/1.gif",
		"img/comecome/baixo/2.gif",
		"img/comecome/baixo/3.gif",
		"img/comecome/traz/1.gif",
		"img/comecome/traz/2.gif",
		"img/comecome/traz/3.gif",
		"img/comecome/cima/1.gif",
		"img/comecome/cima/2.gif",
		"img/comecome/cima/3.gif",
		
		// monstrinhos
		
		"img/monstrinhos/forte/1/1.gif",
		"img/monstrinhos/forte/1/2.gif",
		"img/monstrinhos/forte/1/3.gif",	
		"img/monstrinhos/forte/2/1.gif",
		"img/monstrinhos/forte/2/2.gif",
		"img/monstrinhos/forte/2/3.gif",
		"img/monstrinhos/forte/3/1.gif",
		"img/monstrinhos/forte/3/2.gif",
		"img/monstrinhos/forte/3/3.gif",
		"img/monstrinhos/forte/4/1.gif",
		"img/monstrinhos/forte/4/2.gif",
		"img/monstrinhos/forte/4/3.gif",
		"img/monstrinhos/forte/5/1.gif",
		"img/monstrinhos/forte/5/2.gif",
		"img/monstrinhos/forte/5/3.gif",
		"img/monstrinhos/forte/6/1.gif",
		"img/monstrinhos/forte/6/2.gif",
		"img/monstrinhos/forte/6/3.gif",
		
		"img/monstrinhos/fraco/1.gif",
		"img/monstrinhos/fraco/2.gif",
		"img/monstrinhos/fraco/3.gif",
		
		"img/monstrinhos/meiofraco/1.gif",
		"img/monstrinhos/meiofraco/2.gif",
		"img/monstrinhos/meiofraco/3.gif",
		
		"img/monstrinhos/muitofraco/1.gif",
		"img/monstrinhos/muitofraco/2.gif",
		"img/monstrinhos/muitofraco/3.gif",
		
	};
	
	private final static String[] CAMINHOS_SONS = {
		"audio/comeu.wav",	
		"audio/comeubg.wav",
		"audio/passou.wav",
		"audio/zerou.wav",
		"audio/gameover.wav",		
		"audio/ooh.wav",
		"audio/oops.wav",
		"audio/risadamaligna.wav",
		"audio/atravessarparedes.wav",
		"audio/naoatravessarparedes.wav",
		"audio/woody.wav",
		"audio/fase/1.wav",	
		"audio/fase/2.wav",
		"audio/fase/3.wav",
		"audio/fase/4.wav",
		"audio/fase/5.wav",
		"audio/vida/1.wav",
		"audio/vida/2.wav",
		"audio/vida/3.wav",
		"audio/vida/4.wav"		
	};
	
	private final static ConfFase[] CONF_FASES = {
		new ConfFase1(),
		new ConfFase2(),
		new ConfFase3(),
		new ConfFase4(),
		new ConfFase5()
	};
	
	static {
		conf = new Conf2();
	}
	
	public static Conf2 getInstance() {
		return conf;
	}
	
	public void configurarJogo(Jogo jogo, Figura figura, Audio audio, int larguraTela, int alturaTela) {
		try {
			figura.inicializar(CAMINHOS_IMAGENS);
			audio.inicializar(CAMINHOS_SONS);
			jogo.setNVidas(NUMERO_DE_VIDAS);
			jogo.setNVidasConf(NUMERO_DE_VIDAS);
			jogo.setDificuldade(DIFICULDADE);
			jogo.getTruquesJogo().put(Jogo.CHAVE_TRUQUE_ATRAVESSAR_PAREDES, new Truque(TRUQUE_ATRAVESSAR_PAREDES));
			jogo.getTruquesJogo().put(Jogo.CHAVE_TRUQUE_MUDAR_DE_FASE, new Truque(TRUQUE_MUDAR_DE_FASE));
			jogo.getTruquesMenuJogo().put(Jogo.CHAVE_TRUQUE_MUDAR_NUMERO_DE_VIDAS, new Truque(TRUQUE_MUDAR_NUMERO_DE_VIDAS));
			jogo.setFases(getFases(jogo, larguraTela, alturaTela));
		} catch(TabuleiroException e) {
			JOptionPane.showMessageDialog(null, e, "Falha na Configurao", JOptionPane.ERROR_MESSAGE);
		} catch(Exception e) {
			JOptionPane.showMessageDialog(null, e, "Falha na Configurao", JOptionPane.ERROR_MESSAGE);
		}			
	}
	
	private Fase[] getFases(Jogo jogo, int larguraTela, int alturaTela) throws TabuleiroException {		
		Fase[] fases = new Fase[CONF_FASES.length];
		for(int i = 0; i < fases.length; i++)
			fases[i] = CONF_FASES[i].getFase(jogo, larguraTela, alturaTela);		
		return fases;
	}
						
}
