package italo.comecome.conf;

import italo.comecome.logica.Fase;
import italo.comecome.logica.Jogo;
import italo.comecome.logica.Tabuleiro;
import italo.comecome.logica.TabuleiroException;
import italo.comecome.personagem.ComeCome;
import italo.comecome.personagem.Monstrinho;
import italo.comecome.personagem.util.PersonagemUtil;

public class ConfFase2 implements ConfFase {
	
	public final static String CAMINHO_DA_IMAGEM_DO_TABULEIRO = "img/tabuleiro/2.gif";
	
	public final static int NUMERO_DA_FASE = 2;
	public final static int NUMERO_DE_BOLINHAS = 194;
	public final static int NUMERO_DE_BOLINHAS_GRANDES = 8;
	public final static int NUMERO_DE_MONSTRINHOS = 3;
	public final static int SLEEP_DO_COMECOME = 40;
	public final static int SLEEP_DOS_MONSTRINHOS[] = {50, 55, 50};
	public final static int INDICE_DOS_MONSTRINHOS[] = {1, 2, 3};
	
	public final static int NUMERO_CELULAS_HORIZONTAL = 13;
	public final static int NUMERO_CELULAS_VERTICAL = 9;
	public final static int LARGURA_MAXIMA_TABULEIRO = 800;
	public final static int ALTURA_MAXIMA_TABULEIRO = 600;
	public final static int FATOR_DIMENSAO_INICIAL = 0;
	public final static int FATORES_MINI_CELULA[] = {6, 8, 7, 5, 4};
		
	public final static boolean[][] HORIZONTAL_LIVRE = {
		{false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false},
		{true  ,false ,false ,true  ,false ,true  ,false ,true  ,false ,true  ,false ,false ,true },
		{true  ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,true },
		{true  ,true  ,false ,false ,true  ,true  ,false ,true  ,true  ,false ,false ,true  ,true },
		{true  ,false ,true  ,true  ,false ,false ,false ,false ,false ,true  ,true  ,false ,true },
		{true  ,false ,true  ,true  ,false ,false ,false ,false ,false ,true  ,true  ,false ,true },
		{true  ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,true },
		{true  ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,true },
		{true  ,false ,false ,true  ,false ,true  ,false ,true  ,false ,true  ,false ,false ,true },
		{false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false}
	};
	
	public final static boolean[][] VERTICAL_LIVRE = {
		{false ,true  ,true  ,true  ,true  ,true  ,false ,false ,true  ,true  ,true  ,true  ,true  ,false},
		{false ,true  ,true  ,true  ,false ,true  ,false ,false ,true  ,false ,true  ,true  ,true  ,false},
		{false ,false ,false ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,false ,false ,false},
		{false ,true  ,false ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,false ,true  ,false},
		{true  ,true  ,true  ,false ,false ,true  ,true  ,true  ,true  ,false ,false ,true  ,true  ,true },
		{false ,true  ,false ,false ,true  ,true  ,true  ,true  ,true  ,true  ,false ,false ,true  ,false},
		{false ,false ,false ,true  ,true  ,false ,true  ,true  ,false ,true  ,true  ,false ,false ,false},
		{false ,true  ,true  ,true  ,false ,true  ,false ,false ,true  ,false ,true  ,true  ,true  ,false},
		{false ,true  ,true  ,true  ,true  ,true  ,false ,false ,true  ,true  ,true  ,true  ,true  ,false}
	};
	
	public final static boolean[][] BOLINHAS = {
		{true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,false ,false ,false ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true },
		{true  ,false ,false ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,false ,false ,true },
		{true  ,true  ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,false ,false ,false ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,true  ,true },
		{true  ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,true },
		{true  ,false ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,false ,true },
		{true  ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,true },
		{true  ,true  ,true  ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,true  ,true  ,true },
		{false ,false ,false ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,false ,false ,false},
		{true  ,true  ,true  ,true  ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,true  ,true  ,true  ,true },
		{false ,false ,false ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,false ,false ,false},
		{true  ,true  ,true  ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,true  ,true  ,true },
		{true  ,false ,true  ,false ,true  ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,false ,true  ,false ,true  ,false ,true },
		{true  ,false ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,false ,true  ,false ,true },
		{true  ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,false ,false ,true  ,false ,true  ,false ,true },
		{true  ,true  ,true  ,true  ,true  ,true  ,true  ,false ,true  ,true  ,true  ,false ,false ,false ,true  ,true  ,true  ,false ,true  ,true  ,true  ,true  ,true  ,true  ,true },
		{true  ,false ,false ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,true  ,false ,false ,false ,false ,false ,true },
		{true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,false ,false ,false ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true  ,true }
	};


			
	public final static int[][] BOLINHAS_GRANDES = {
		{0 ,4},
		{0 ,20},
		{16 ,4},
		{16 ,20},
		{4 ,0},
		{12 ,0},
		{4 ,24},
		{12 ,24}
	};
	
	public final static String[][] DIRECOES_INICIAIS_MONSTRINHOS = {
		{"frente" ,"frente" ,"cima"  },
		{"cima"  },
		{"traz"   ,"traz"   ,"cima"  }
	};
	
	public final static int[][] POSICOES_CELULAS_INICIAIS_COMECOME = {
		{5 ,6}
	};
	
	public final static int[][] POSICOES_CELULAS_INICIAIS_MONSTRINHOS = {
		{4 ,4},
		{6 ,4},
		{8 ,4}
	};

	
	public final static int[][] INDICES_PORTAS = {
		{4 ,6}
	};
				
	public Fase getFase(Jogo jogo, int larguraTela, int alturaTela) throws TabuleiroException {
		ComeCome comecome = new ComeCome(jogo, "comecome", 0, 40);
		Monstrinho[] monstrinhos = getMonstrinhos(jogo);
		Tabuleiro tabuleiro = getTabuleiro(larguraTela, alturaTela);
		Fase fase = new Fase();
		fase.setComeCome(comecome);
		fase.setMonstrinhos(monstrinhos);
		fase.setTabuleiro(tabuleiro);
		fase.setCaminhoImagemTabuleiro(CAMINHO_DA_IMAGEM_DO_TABULEIRO);
		fase.setNumero(NUMERO_DA_FASE);
		fase.setNBolinhasIniciais(NUMERO_DE_BOLINHAS);
		fase.setNBolinhasGrandesIniciais(NUMERO_DE_BOLINHAS_GRANDES);			
		fase.setHorizontalLivre(HORIZONTAL_LIVRE);
		fase.setVerticalLivre(VERTICAL_LIVRE);
		fase.setBolinhasIniciais(BOLINHAS);
		fase.setBolinhasGrandesIniciais(BOLINHAS_GRANDES);
		fase.setDirecoesIniciaisMonstrinhos(getVetorDirecoesIniciaisMonstrinhos(tabuleiro.getFatorMiniCelula()));
		fase.setIndicesPortas(INDICES_PORTAS);
		fase.setPosicaoCelulaInicialComecome(POSICOES_CELULAS_INICIAIS_COMECOME);
		fase.setPosicoesCelulasIniciaisMonstrinhos(POSICOES_CELULAS_INICIAIS_MONSTRINHOS);
		return fase;
	}
			
	public Tabuleiro getTabuleiro(int larguraTela, int alturaTela) throws TabuleiroException {
		return new Tabuleiro(larguraTela, alturaTela,
			Math.min(LARGURA_MAXIMA_TABULEIRO, larguraTela), Math.min(ALTURA_MAXIMA_TABULEIRO, alturaTela), 
			FATOR_DIMENSAO_INICIAL, 
			NUMERO_CELULAS_HORIZONTAL, NUMERO_CELULAS_VERTICAL, 
			FATORES_MINI_CELULA);		
	}
	
	public Monstrinho[] getMonstrinhos(Jogo jogo) {
		Monstrinho[] monstrinhos = new Monstrinho[INDICE_DOS_MONSTRINHOS.length];
		for(int i = 0; i < INDICE_DOS_MONSTRINHOS.length; i++) {
			int indice = INDICE_DOS_MONSTRINHOS[i];
			int sleep = SLEEP_DOS_MONSTRINHOS[i];
			monstrinhos[i] = new Monstrinho(jogo, "monstrinhos", indice, sleep);
		}	
		return monstrinhos;
	}
	
	public int[][] getVetorDirecoesIniciaisMonstrinhos(int fatorMC) {
		int[][] vetor = new int[NUMERO_DE_MONSTRINHOS][];
		for(int i = 0; i < vetor.length; i++) {
			String[] direcoes = DIRECOES_INICIAIS_MONSTRINHOS[i];
			vetor[i] = new int[direcoes.length*fatorMC];
			for(int j = 0; j < direcoes.length; j++) {
				String direcao = direcoes[j];
				for(int k = 0; k < fatorMC; k++) 
					vetor[i][(j*fatorMC)+k] = PersonagemUtil.getDirecaoINT(direcao);				
			}
		}		
		return vetor;
	}

}
