package italo.comecome.entrada;

import italo.comecome.gui.ContainerJogo;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import java.util.List;

class Teclado implements KeyListener {
	
	private ContainerJogo container;
	
	private List<KeyListener> listeners = new ArrayList<KeyListener>();
	
	public Teclado(ContainerJogo container) {
		this.container = container;
	}
	
	public void addKeyListenerTeclado(KeyListener listener) {
		listeners.add(listener);	
	}
	
	public void removeKeyListenerTeclado(KeyListener listener) {
		listeners.remove(listener);	
	}
	
	public void addKeyListener() {
		container.getContainer().addKeyListener(this);	
	}
	
	public void removeKeyListener() {
		container.getContainer().removeKeyListener(this);
	}

	public void keyPressed(KeyEvent e) {
		for(int i = 0; i < listeners.size(); i++)
			listeners.get(i).keyPressed(e);
	}

	public void keyReleased(KeyEvent e) {
		for(int i = 0; i < listeners.size(); i++)
			listeners.get(i).keyReleased(e);
	}

	public void keyTyped(KeyEvent e) {
		for(int i = 0; i < listeners.size(); i++)
			listeners.get(i).keyTyped(e);
	}
	
}
