package italo.comecome.gui;

import italo.comecome.audio.Audio;
import italo.comecome.gui.desenho.CarregamentoIT;
import italo.comecome.gui.desenho.Desenho;
import italo.comecome.gui.figura.Figura;

import java.awt.Container;
import java.awt.Image;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

public interface ContainerJogo {

	public void finalizar();
	
	public void carregarImagens(CarregamentoIT carregamento, int nArquivosMidia, int nArquivosCarregados);
	
	public void carregarSons(CarregamentoIT carregamento, int nArquivosMidia, int nArquivosCarregados);
	
	public URL getURL(String caminho);
	
	public InputStream getInputStream(String caminho) throws IOException;
	
	public String getCaminho(String caminho);
	
	public void playAudioClip(String caminho);
	
	public Image getImage(String caminho);
	
	public void desenhar(String caminho);
	
	public Container getContainer();
	
	public Figura getFigura();
	
	public Audio getSom();
	
	public PainelPersonalizado getPainelPersonalizado();
	
	public Desenho getFundo();
	
}
