package italo.comecome.gui.evento;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public abstract class EntradaJanela implements KeyListener {
	
	private boolean altPressionado = false;
			
	public void iniciar() {
		altPressionado = false;
	}
	
	public void keyPressed(KeyEvent e){
		teclaPressionada(e.getKeyChar());
		if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			if(altPressionado) {
				altEnterPressionado();
			}
		} else if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
			escPressionado();			
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = true;
		}
	}
	
	public void keyReleased(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = false;
		}
	}

	public void keyTyped(KeyEvent e) {
		
	}
	
	public abstract void teclaPressionada(char tecla);
	public abstract void escPressionado();
	public abstract void altEnterPressionado();
	
}
