package italo.comecome.gui.figura;

import italo.comecome.gui.ContainerJogo;
import italo.comecome.gui.desenho.CarregamentoIT;

import java.awt.Image;


public class Figura {
		
	public final static String CAMINHO = "img/";
	public final static String CAMINHO_ABERTURA = "img/abertura/";
	public final static String CAMINHO_MONSTRINHOS = "img/monstrinhos/";
	public final static String CAMINHO_COMECOME = "img/comecome/";
	public final static String CAMINHO_MENU = "img/menu/";
	public final static String CAMINHO_TABULEIRO = "img/tabuleiro/";
	public final static String CAMINHO_MENSAGENS = "img/mensagens/";
	public final static String CAMINHO_MENSAGENS_VIDAS = "img/mensagens/vidas/";
	public final static String MENSAGEM_GAMEOVER = "img/mensagens/gameover.gif";
	public final static String MENSAGEM_PASSOU = "img/mensagens/passou.gif";
	public final static String MENSAGEM_ZEROU = "img/mensagens/zerou.gif";
	public final static String MENSAGEM_PAUSA = "img/mensagens/pausa.gif";	
	public final static String EXT = ".gif";

	private ContainerJogo container;
	private ConjuntoFigura conjuntoFigura;
	private String[] caminhos;
	private int numero = 1;
	private int quantidade = 3;
		
	public Figura(ContainerJogo container) {
		this.container = container;
	}
	
	public void inicializar(String[] caminhos) {
		this.caminhos = caminhos;	
		this.conjuntoFigura = new ConjuntoFigura(container, caminhos);
	}
	
	public Imagem novaImagem(String tipo, String id, String direcao, String estado) {
		Imagem i;
		if(tipo.equals("comecome")) {
			i = new Imagem(this, "img/"+tipo+"/"+direcao+"/"+numero+".gif");
		} else {
			if(estado.equals("forte")) {
				i = new Imagem(this, "img/"+tipo+"/"+estado+"/"+id+"/"+numero+".gif");
			} else {
				i = new Imagem(this, "img/"+tipo+"/"+estado+"/"+numero+".gif");
			}			
		}	
		numero = (numero%quantidade)+1;
		return i;
	}
	
	public Imagem novaImagem(String caminho) {
		return new Imagem(this, caminho);
	}
	
	public Imagem novaImagem(String caminho, int largura, int altura) {
		return new Imagem(this, caminho, largura, altura);
	}
	
	public void carregarImagens(CarregamentoIT carregamento, int nArquivosCarregados, int porcentagemInicial) {
		conjuntoFigura.carregarImagens(carregamento, nArquivosCarregados, porcentagemInicial);
	}
	
	public Image getImage(String caminho) {
		return conjuntoFigura.getImagem(caminho);
	}
		
	public ConjuntoFigura getConjuntoFigura() {
		return conjuntoFigura;
	}

	public String[] getCaminhos() {
		return caminhos;
	}

	public void setCaminhos(String[] caminhos) {
		this.caminhos = caminhos;
	}
					
}
